package model

import (
	pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"
)

type ConfigBarnType struct {
	Id        int64                 `json:"id"`
	Name      string                `json:"name"`
	Remarks   string                `json:"remarks"`
	IsShow    pasturePb.IsShow_Kind `json:"is_show"`
	CreatedAt int64                 `json:"created_at"`
	UpdatedAt int64                 `json:"updated_at"`
}

func (c *ConfigBarnType) TableName() string {
	return "config_barn_type"
}

type ConfigBarnTypeSlice []*ConfigBarnType

func (c ConfigBarnTypeSlice) ToPB() []*pasturePb.BarnTypeList {
	res := make([]*pasturePb.BarnTypeList, len(c))
	for i, d := range c {
		res[i] = &pasturePb.BarnTypeList{
			Value:    int32(d.Id),
			Label:    d.Name,
			Disabled: true,
		}
	}
	return res
}
