package backend

import (
	"context"
	"kpt-pasture/model"
	"net/http"

	pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"
)

func (s *StoreEntry) BarnTypeList(ctx context.Context) (*pasturePb.BarnTypeListResponse, error) {
	configBarnTypeList := make([]*model.ConfigBarnType, 0)

	if err := s.DB.Table(new(model.ConfigBarnType).TableName()).Find(&configBarnTypeList).Error; err != nil {
		return nil, err
	}

	return &pasturePb.BarnTypeListResponse{
		Code:    http.StatusOK,
		Message: "ok",
		Data:    model.ConfigBarnTypeSlice(configBarnTypeList).ToPB(),
	}, nil
}
